package com.zhentao.suanfa;

import java.util.HashMap;
import java.util.Map;

public class Test01 {
    public String min(String s,String t){
        if (s==null||t==null||s.length()<t.length()){
            return "";
        }

        Map<Character, Integer> targetMap = new HashMap<>();
        for (char c : t.toCharArray()) {
            targetMap.put(c, targetMap.getOrDefault(c, 0)+1);
        }
        int required = targetMap.size();
        int left=0,right=0;
        int formed=0;
        Map<Character, Integer> windowMap = new HashMap<>();
        int minLen = Integer.MAX_VALUE;
        int minLeft=0;

        while (right<s.length()){
            char c = s.charAt(right);
            windowMap.put(c, windowMap.getOrDefault(c, 0)+1);
            if (targetMap.containsKey(c)&&windowMap.get(c).intValue()==targetMap.get(c).intValue()){
                formed++;
            }

            while (left<=right&&formed==required){
                 c = s.charAt(left);
                if (right-left+1<minLen){
                    minLen = right - left + 1;
                    minLeft = left;
                }

                windowMap.put(c, windowMap.get(c)-1);
                if (targetMap.containsKey(c)&&windowMap.get(c).intValue()<targetMap.get(c).intValue()){
                    formed--;
                }
                left++;
            }
            right++;
        }
        return minLen==Integer.MAX_VALUE?"":s.substring(minLeft,minLeft+minLen);
    }
    public static void main(String[] args) {
        Test01 test01 = new Test01();
        String s = "ADOBECODEBANC";
        String t = "ABC";
        System.out.println(test01.min(s, t));
    }
}
