package com.zhentao.controller;

import cn.hutool.crypto.digest.DigestUtil;
import org.springframework.util.DigestUtils;

public class HutoolsController {
    public static boolean callInterface1(String appId,String goodsId,String reqId,String reqTime,String appKey){
        String signature = genreateSignature(appId, goodsId, reqId, reqTime, appKey);
        return verifySignature(appId, goodsId, reqId, reqTime, appKey, signature);
    }

    public static boolean callInterface2(String appId,String goodsId,String reqId,String reqTime,String appKey){
        String signature = genreateSignature(appId, goodsId, reqId, reqTime, appKey);
        return verifySignature(appId, goodsId, reqId, reqTime, appKey, signature);
    }

    public static String genreateSignature(String appId,String goodsId,String reqId,String reqTime,String appKey){
      String source=  appId+goodsId+reqId+reqTime+appKey;
        return DigestUtil.md5Hex(source);
    }

    public static boolean verifySignature(String appId,String goodsId,String reqId,String reqTime,String appKey,String signature){
        String genreateSignature = genreateSignature(appId, goodsId, reqId, reqTime, appKey);
        return genreateSignature.equals(signature);
    }


}
